(document:surround "/std/frame")

;;; Functions

(define (init-alternatives)
  (woo-catch/message
    (lambda()
      (alternativeslist enumref "/alternatives")
      (and (positive? (alternativeslist count)) (alternativeslist current 0)))))

(define (read-alternatives name)
  (woo-catch/message
    (lambda()
      (let ((data (woo-read-first "/alternatives" 'name name)))
	(candidateslist enumref (list "/alternatives/avail_candidate/" 'name name)
			value (woo-get-option data 'current))
	(manual value (woo-get-option data 'manual))))))

(define (write-alternatives)
  (woo-catch/message
    (lambda()
      (woo-write "/alternatives/"
		 'name (alternativeslist value)
		 'current (candidateslist value)
		 'manual (manual value)))))

;;; UI

(gridbox columns "10;80;10"
	 ;;
	 (spacer)
	 (label text (_ "Alternatives:"))
	 (spacer)

	 ;;
	 (spacer)
	 (document:id alternativeslist (listbox
					 (when selected
					   (read-alternatives (alternativeslist value))
					   (update-effect))))
	 (spacer)

	 ;;
	 (label colspan 3)

	 ;;
	 (spacer)
	 (separator)
	 (spacer)

	 ;;
	 (spacer)
	 (label text (_ "Candidates:") name "current")
	 (spacer)

	 (spacer)
	 (document:id candidateslist (listbox name "current"))
	 (spacer)
	 
	 ;;
	 (spacer)
	 (document:id manual (checkbox text (_ "Choose candidate manually") name "manual"))
	 (spacer)
	 (spacer)
	 ;;
	 (label text (small
		       (_ "In most cases candidates selection works well automatically using weight written in their config file, but you can choose variant manually"))
		text-wrap #t)
	 (spacer)
	 
	 ;;
	 (label colspan 3)
	 
	 ;;
	 (spacer)
	 (document:id apply-button
		      (button text (_ "Apply")
			      align "left"
			      (when clicked (write-alternatives))))
	 (spacer))

;;; Logic
(effect-disable "current" "manual" #f)

(document:root
  (when loaded
    (init-alternatives)
    (read-alternatives "")
    (init-effect)))
